// Name        : Keith Vertanen
// Username    : kvertanen
// Description : A filled circle shape class 

public class Circle extends Shape
{
	private double radius = 0.0;

	// Construct a circle at (x, y) with given radius
	public Circle(double x, double y, double radius)
	{
		super(x, y);
		this.radius = radius;
	}

	// Draw a filled circle 
	public void draw()
	{
		StdDraw.setPenColor(getColor());
		StdDraw.filledCircle(getX(), getY(), radius);
	}
	
	// See if a point is inside (or on the border) of this circle
	public boolean intersects(double x, double y)
	{
		return (distance(x, y) <= radius);			
	}	

}
