import java.util.Iterator;
import java.util.Arrays;

public class RandomShapes implements Iterable<Shape>
{
    private Shape [] shapes;

    public Iterator<Shape> iterator()
    {
        return new ArrayIterator();
    }
    
    private class ArrayIterator implements Iterator<Shape>
    {
        private int i = 0;
        public boolean hasNext() { return i < shapes.length; }
        public Shape next()      { return shapes[i++];       }        
        public void remove()     {                           }
    }
    
    public RandomShapes(int num)
    {
        if (num <= 0)
            return;    
        shapes = new Shape[num];
        for (int i = 0; i < num; i++)
        {
            double x    = Math.random();
            double y    = Math.random();
            if (Math.random() < 0.5)
                shapes[i] = new Circle(x, y, Math.random() * 0.1);
            else
                shapes[i] = new Rectangle(x, y, Math.random() * 0.1, Math.random() * 0.1);
        }
        
        // Sort the shapes according to their area.
        // Note that since shapes is an array, we us Arrays.sort().
        // If it was an ArrayList, we'd use Collections.sort().
        Arrays.sort(shapes);
    }
    
    public static void main(String [] args)
    {
        RandomShapes shapes = new RandomShapes(100);

        // Draw the shapes in order from smallest area to largest area
        for (Shape s : shapes)
        {
            s.draw();
            StdDraw.show(100);
        }
    }
}
