// Name        : Keith Vertanen
// Username    : kvertanen
// Description : A filled rectangle shape class 

public class Rectangle extends Shape
{
	private double width 	= 0.0;
	private double height = 0.0;

	// Construct a rectangle at (x, y) with given width and height
	public Rectangle(double x, double y, double width, double height)
	{
		super(x, y);
		this.width = width;
		this.height = height;
	}

	// Draw a filled circle 
	public void draw()
	{
		StdDraw.setPenColor(getColor());
		StdDraw.filledRectangle(getX(), getY(), width / 2.0, height / 2.0);
	}
	
	// See if a point is intersects this rectangle
	public boolean intersects(double x, double y)
	{
		double left   = this.getX() - (width  / 2.0);
		double right  = this.getX() + (width  / 2.0);
		double top    = this.getY() + (height / 2.0);
		double bottom = this.getY() - (height / 2.0);
		
		return ((x >= left) && (x <= right) && (y >= bottom) && (y <= top)); 			
	}	
	
}
