// Name        : Keith Vertanen
// Username    : kvertanen
// Description : Abstract base class for various drawable shapes

import java.awt.Color;

public abstract class Shape // TBD
{
	private double x 		= 0.0;							// x-center of this shape
	private double y 		= 0.0;							// y-center of this shape
	private Color  color 	= new Color(0.0f, 0.0f, 1.0f);	// color of this shape

	// Construct at (x, y) with the default color
	public Shape(double x, double y)
	{
		this.x = x;
		this.y = y;
	}

    // Getter method for the color
    public Color getColor()
    {
        return color;
    }
    
    // Getter method for the x-center
    public double getX()
    {
        return x;
    }
    
    // Getter method for the y-center
    public double getY()
    {
        return y;
    }   	
		
	// Calculate the distance between our center and the given point
	public double distance(double x, double y)
	{
		double deltaX = this.x - x;
		double deltaY = this.y - y;
		return Math.sqrt(deltaX * deltaX + deltaY * deltaY);
	}

	// Change the color of the shape
	public void setColor(double r, double g, double b)
	{
		color = new Color((float) r, (float) g, (float) b);
	}
	
	// Draw the shape
	public abstract void draw();
	
	// See if the given (x, y) coordinate intersects the shape
	public abstract boolean intersects(double x, double y);
	
	// TBD: implement the following two methods:
	
	// Calculate the area of a shape
	//public TBD double area();
	
	// Compare ourselves with another shape
	//public TBD compareTo(Shape other)
}
